import Data.List
import Text.Printf

max_n = 1000000
find_min x p | p x       = last $ x : takeWhile p [x-1, x-2 .. 0]
             | otherwise = head $ dropWhile (not . p) [x+1, x+2 ..]

test w a d = and [delete n m && join n m | n <- [0 .. max_n],
                                           let m = flr $ max 1 (w * n + d)]
 where
  delete n m = n == 0 || rebalance (n-1) m
  join n m = rebalance n (m+increment)
    where increment = max 1 $ ceil ((n+m+1-d) / (w+1) - 1)

  rebalance n m = and [rebalance' n m x | x <- nub [x_min, x_mid - 1,
                                                    x_mid, m - 1 - x_min]]
    where x_min = find_min (flr $ m     / (w+1)) (\x -> balanced x (m-1-x))
          x_mid = find_min (flr $ m * a / (a+1)) (\x -> x >= a * (m-1-x))

  rebalance' n m x
    | x < a * y = balanced n x && balanced (n + 1 + x) y
    | otherwise = balanced n s && balanced t y && balanced (n+1+s) (t+1+y) &&
                  balanced n t && balanced s y && balanced (n+1+t) (s+1+y)
   where(y,s,t)=(m-1-x,find_min (flr$x/(w+1)) (\s->balanced s (x-1-s)),x-1-s)

  balanced n m = max 1 (w * n + d) >= m && n <= max 1 (w * m + d)

  flr, ceil :: Double -> Double
  flr = fromInteger . floor
  ceil = fromInteger . ceiling

results = [ (w, a, d, test w a d) | w <- [2, 2.125 .. 5],
                                    a <- [1, 1.125 .. 3], d <- [0 .. 3]]

main = mapM_ format results
  where format (w, a, d, res) =
          printf "%g %g %c\n" (w - 1/32 + if d==1||d==3 then 1/16 else 0)
                              (a + 1/32 - if d>1 then 1/16 else 0)
                              (b2chr res)

        b2chr b = if b then '1' else '0'
