import Criterion.Main
import Data.List
-- import Containers.Tree25 as T
-- import Containers.Tree30 as T
import Containers.Tree40 as T
-- import ContainersOne.Tree25 as T
-- import ContainersOne.Tree30 as T
-- import ContainersOne.Tree40 as T
-- import ContainersOneReor.Tree25 as T
-- import ContainersOneReor.Tree30 as T
-- import ContainersOneReor.Tree40 as T
import System.Environment
import System.Random

asclist n = [1..n]
rndlist n = sum list `seq` list
  where list = take n $ randoms $ mkStdGen 1234

insertfun :: [Int] -> T.BBTree Int
insertfun xs = foldl' (flip T.insert) T.Nil xs

deletefun :: (T.BBTree Int, [Int]) -> T.BBTree Int
deletefun (t, xs) = foldl' (flip T.delete) t xs

lookupfun :: (T.BBTree Int, [Int]) -> T.BBTree Int
lookupfun (t, xs) = foldl' (\t x-> T.lookup x t `seq` t) t xs

foldfun :: T.BBTree Int -> T.BBTree Int
foldfun t = T.fold (+) 0 t `seq` T.Nil

splitfun :: (T.BBTree Int, [Int]) -> T.BBTree Int
splitfun (t, l) = splitfun' t l
 where splitfun' t [] = T.Nil
       splitfun' t (x:xs) = case T.split x t of (l, r) -> l `seq` r `seq` splitfun' t xs

main = do
  defaultMain benchs
 where
  benchs = map (uncurry bench) $
    [("insert_asc-10^" ++ show i, nf (T.eval . insertfun) (asclist (10^i))) | i<-[1..6]] ++
    [("insert_rnd-10^" ++ show i, nf (T.eval . insertfun) (rndlist (10^i))) | i<-[1..6]] ++
    [("delete_asc-10^" ++ show i, nf (T.eval . deletefun) ((\l->(insertfun l, l)) $ asclist (10^i))) | i<-[1..6]] ++
    [("delete_rnd-10^" ++ show i, nf (T.eval . deletefun) ((\l->(insertfun l, l)) $ rndlist (10^i))) | i<-[1..6]] ++
    [("lookup_asc-10^" ++ show i, nf (T.eval . lookupfun) ((\l->(insertfun l, l)) $ asclist (10^i))) | i<-[1..6]] ++
    [("lookup_rnd-10^" ++ show i, nf (T.eval . lookupfun) ((\l->(insertfun l, l)) $ rndlist (10^i))) | i<-[1..6]] ++
    [("fold_asc-10^" ++ show i, nf (T.eval . foldfun) (insertfun $ asclist (10^i))) | i<-[1..6]] ++
    [("fold_rnd-10^" ++ show i, nf (T.eval . foldfun) (insertfun $ rndlist (10^i))) | i<-[1..6]] ++
    [("split_asc-10^" ++ show i, nf (T.eval . splitfun) ((\l->(insertfun l, l)) $ asclist (10^i))) | i<-[1..6]] ++
    [("split_rnd-10^" ++ show i, nf (T.eval . splitfun) ((\l->(insertfun l, l)) $ rndlist (10^i))) | i<-[1..6]]
