#ifndef BALANCE
#define BALANCE
#endif

{-# NOINLINE balanceL #-}
balanceL l x r = BALANCE case r of
  Nil -> case l of
           Nil -> One x
           One _ -> Node l 2 x Nil
           Node Nil _ lx (One lrx) -> Node (One lx) 3 lrx (One x)
           Node ll@(One _) _ lx Nil -> Node ll 3 lx (One x)
           Node ll@(One _) _ lx lr@(One _) -> Node ll 4 lx (Node lr 2 x Nil)
           Node ll@(One _) ls lx lr@(Node Nil _ lrx (One lrrx)) -> Node (Node ll 3 lx (One lrx)) 5 lrrx (One x)
           Node ll@(One _) ls lx lr@(Node lrl@(One _) _ lrx Nil) -> Node (Node ll 3 lx lrl) 5 lrx (One x)
           Node ll@(Node _ _ _ _) ls lx lr@(One lrx) -> Node ll (1+ls) lx (Node lr 2 x Nil)

  One _ -> case l of
           Nil -> Node Nil 2 x r
           One _ -> Node l 3 x r
           Node ll@(One _) ls lx lr@(Node lrl lrs lrx lrr) -> Node (Node ll (2+size lrl) lx lrl) (2+ls) lrx (Node lrr (2+size lrr) x r)
           Node ll@(Node _ _ _ _) ls lx lr@(One lrx) -> Node ll (2+ls) lx (Node lr 3 x r)
           Node ll@(Node _ lls _ _) ls lx lr@(Node lrl lrs lrx lrr)
             | lrs `single_rotation` lls -> Node ll (2+ls) lx (Node lr (2+lrs) x r)
             | otherwise -> Node (Node ll (1+lls+size lrl) lx lrl) (2+ls) lrx (Node lrr (2+size lrr) x r)
           Node _ ls _ _ -> Node l (2+ls) x r

  Node _ rs _ _ -> case l of
           Nil -> Node l (1+rs) x r
           One _ -> Node l (2+rs) x r
           Node ll ls lx lr
             | ls `much_bigger_than` rs  -> case (ll, lr) of
                 (Node _ lls _ _, Node lrl lrs lrx lrr)
                   | lrs `single_rotation` lls -> Node ll (1+ls+rs) lx (Node lr (1+rs+lrs) x r)
                   | otherwise -> Node (Node ll (1+lls+size lrl) lx lrl) (1+ls+rs) lrx (Node lrr (1+rs+size lrr) x r)
                 (_, _) -> error "Failure in balanceL"
             | otherwise -> Node l (1+ls+rs) x r

{-# NOINLINE balanceR #-}
balanceR l x r = BALANCE case l of
  Nil -> case r of
           Nil -> One x
           One _ -> Node Nil 2 x r
           Node Nil _ lx rr@(One _) -> Node (One x) 3 lx rr
           Node (One lrx) _ lx Nil -> Node (One x) 3 lrx (One lx)
           Node rl@(One _) _ lx rr@(One _) -> Node (Node Nil 2 x rl) 4 lx rr
           Node rl@(One lrx) ls lx rr@(Node _ _ _ _) -> Node (Node Nil 2 x rl) (1+ls) lx rr
           Node rl@(Node Nil _ lrx rlr@(One _)) ls lx rr@(One _) -> Node (One x) 5 lrx (Node rlr 3 lx rr)
           Node rl@(Node (One lrrx) _ lrx Nil) ls lx rr@(One _) -> Node (One x) 5 lrrx (Node (One lrx) 3 lx rr)

  One _ -> case r of
           Nil -> Node l 2 x Nil
           One _ -> Node l 3 x r
           Node rl@(One lrx) ls lx rr@(Node _ _ _ _) -> Node (Node l 3 x rl) (2+ls) lx rr
           Node rl@(Node rll lrs lrx rlr) ls lx rr@(One _) -> Node (Node l (2+size rll) x rll) (2+ls) lrx (Node rlr (2+size rlr) lx rr)
           Node rl@(Node rll lrs lrx rlr) ls lx rr@(Node _ lls _ _)
             | lrs `single_rotation` lls -> Node (Node l (2+lrs) x rl) (2+ls) lx rr
             | otherwise -> Node (Node l (2+size rll) x rll) (2+ls) lrx (Node rlr (1+lls+size rlr) lx rr)
           Node _ ls _ _ -> Node l (2+ls) x r

  Node _ rs _ _ -> case r of
           Nil -> Node l (1+rs) x r
           One _ -> Node l (2+rs) x r
           Node rl ls lx rr
             | ls `much_bigger_than` rs  -> case (rr, rl) of
                 (Node _ lls _ _, Node rll lrs lrx rlr)
                   | lrs `single_rotation` lls -> Node (Node l (1+rs+lrs) x rl) (1+ls+rs) lx rr
                   | otherwise -> Node (Node l (1+rs+size rll) x rll) (1+ls+rs) lrx (Node rlr (1+lls+size rlr) lx rr)
                 (_, _) -> error "Failure in balanceR"
             | otherwise -> Node l (1+ls+rs) x r

{-
balanceR l x r = mirror $ balanceL (mirror r) x (mirror l)
  where mirror (Node l s x r) = Node (mirror r) s x (mirror l)
        mirror t = t
-}
