{-# LANGUAGE BangPatterns #-}
-- import PaperOne.Tree25 as T
-- import PaperOne.Tree30 as T
-- import PaperOne.Tree40 as T
-- import ContainersOne.Tree25 as T
-- import ContainersOne.Tree30 as T
import ContainersOne.Tree40 as T
import System.Environment
import System.Random

count :: BBTree Int -> (Int, Int, Int)
count Nil = (0, 0, 1)
count (One _) = (0, 1, 0)
count (Node left _ _ right) = let (!la, !lb, !lc) = count left
                                  (!ra, !rb, !rc) = count right
                              in (la + ra + 1, lb + rb, lc + rc)

asclist n = [1..n]
rndlist n = sum list `seq` list
  where list = take n $ randoms $ mkStdGen 1234

insertfun :: [Int] -> T.BBTree Int
insertfun xs = foldl (flip T.insert) T.Nil xs

deletehalffun :: [Int] -> T.BBTree Int
deletehalffun xs = foldl (flip T.delete) (insertfun xs) (take (length xs `div` 2) xs)

main = do
  (fun' : len' : inp' : rest) <- getArgs
  let
      fun = case fun' of
              "insert" -> insertfun
              "deletehalf" -> deletehalffun
      len = read len'
      inp = case inp' of
              "asc" -> asclist len
              "rnd" -> rndlist len
  print $ count $ fun inp
