{-# LANGUAGE CPP #-}
import Control.Concurrent
import Data.IORef
import Data.List
-- import Paper.Tree25 as T
-- import Paper.Tree30 as T
-- import Paper.Tree40 as T
-- import PaperOne.Tree25 as T
-- import PaperOne.Tree30 as T
-- import PaperOne.Tree40 as T
-- import Containers.Tree25 as T
-- import Containers.Tree30 as T
-- import Containers.Tree40 as T
-- import ContainersOne.Tree25 as T
-- import ContainersOne.Tree30 as T
-- import ContainersOne.Tree40 as T
-- import ProfContainers.Tree25 as T
-- import ProfContainers.Tree30 as T
import ProfContainers.Tree40 as T
-- import ProfContainersOne.Tree25 as T
-- import ProfContainersOne.Tree30 as T
-- import ProfContainersOne.Tree40 as T
import System.Environment
import System.Random
import Debug.Trace

asclist n = [1..n]
rndlist n = sum list `seq` list
  where list = take n $ randoms $ mkStdGen 1234

insertfun :: [Int] -> T.BBTree Int
insertfun xs = foldl' (flip T.insert) T.Nil xs

deletefun :: T.BBTree Int -> [Int] -> T.BBTree Int
deletefun t xs = foldl' (flip T.delete) t xs

foldfun :: T.BBTree Int -> [Int] -> T.BBTree Int
foldfun t [] = T.fold (+) 0 t `seq` T.Nil

splitfun :: T.BBTree Int -> [Int] -> T.BBTree Int
splitfun t [] = t
splitfun t (x:xs) = case T.split x t of (l, r) -> l `seq` r `seq` splitfun t xs

#ifndef PROFILE_START
#define PROFILE_START
#endif

#ifndef PROFILE_STOP
#define PROFILE_STOP
#endif

main = do
  (iter' : fun' : len' : inp' : rest) <- getArgs
  let iter = read iter'
      len = read len'
      asc = asclist len
      rnd = rndlist len
      tasc = insertfun asc
      trnd = insertfun rnd
  PROFILE_START
  case fun' ++ inp' of
    "insertasc" -> iterate iter insertfun asc
    "insertrnd" -> iterate iter insertfun rnd
    "deleteasc" -> iterate iter (deletefun tasc) asc
    "deleternd" -> iterate iter (deletefun trnd) rnd
    "foldasc" -> iterate iter (foldfun tasc) []
    "foldrnd" -> iterate iter (foldfun trnd) []
    "splitasc" -> iterate iter (splitfun tasc) asc
    "splitrnd" -> iterate iter (splitfun trnd) rnd
  PROFILE_STOP
 where
  iterate :: Int -> (a -> T.BBTree Int) -> a -> IO ()
  iterate 0 _   _   = return ()
  iterate i fun inp = T.eval (fun inp) `seq` iterate (i-1) fun inp
