{-# NOINLINE singleL #-}
singleL l k (Node rl _ rk rr) = node (node l k rl) rk rr
{-# NOINLINE singleR #-}
singleR (Node ll _ lk lr) k r = node ll lk (node lr k r)
{-# NOINLINE doubleL #-}
doubleL l k (Node (One rlk) _ rk rr) =
  node (node l k Nil) rlk (node Nil rk rr)
doubleL l k (Node (Node rll _ rlk rlr) _ rk rr) =
  node (node l k rll) rlk (node rlr rk rr)
{-# NOINLINE doubleR #-}
doubleR (Node ll _ lk (One lrk)) k r =
  node (node ll lk Nil) lrk (node Nil k r)
doubleR (Node ll _ lk (Node lrl _ lrk lrr)) k r =
  node (node ll lk lrl) lrk (node lrr k r)

balance left key right
  | size left + size right <= 1 =
      node left key right
  | size right `much_bigger_than` size left = case right of
      (Node rl _ _ rr)
        | size rl `single_rotation` size rr -> singleL left key right
        | otherwise             -> doubleL left key right
  | size left `much_bigger_than` size right = case left of
      (Node ll _ _ lr)
        | size lr `single_rotation` size ll -> singleR left key right
        | otherwise             -> doubleR left key right
  | otherwise =
      node left key right

{-# INLINE balanceL #-}
balanceL left key right = balance left key right
{-# INLINE balanceR #-}
balanceR left key right = balance left key right
