import Control.Monad
import Data.Maybe
import Data.List
import Debug.Trace
-- import Paper.Tree25 as T
-- import Paper.Tree30 as T
-- import Paper.Tree40 as T
-- import PaperOne.Tree25 as T
-- import PaperOne.Tree30 as T
-- import PaperOne.Tree40 as T
-- import Containers.Tree25 as T
-- import Containers.Tree30 as T
-- import Containers.Tree40 as T
-- import ContainersOne.Tree25 as T
-- import ContainersOne.Tree30 as T
import ContainersOne.Tree40 as T
-- import Paper.Tree49 as TT
-- import Paper.Tree50 as TT
import System.Random
import System.IO.Unsafe
import Test.QuickCheck

valid t = valid' t Nothing Nothing
  where valid' t bl br
          | size t == 0 = True
          | otherwise =
              size t == 1 + size l + size r &&
              (isNothing bl || fromJust bl <= k) &&
              (isNothing br || fromJust br >= k) &&
              (if size l == 0 then size r <= 1 else not (size r `much_bigger_than` size l)) &&
              (if size r == 0 then size l <= 1 else not (size l `much_bigger_than` size r)) &&
              valid' l bl (Just k) && valid' r (Just k) br
          where k = key t
                l = left t
                r = right t

prop_inserts_seq xs = inserts (sort xs)
prop_inserts_rnd xs = inserts xs
inserts :: [Int] -> Bool
inserts xs = final_check $ foldl insert_and_check (T.Nil, True) xs
  where insert_and_check (tree, ok) x | ok, tree' <- T.insert x tree, valid tree' = (tree', True)
                                      | otherwise = (tree, False)
        final_check (tree, ok) = ok && size tree == length (map head $ group $ sort xs)

prop_lookup :: [Int] -> Bool
prop_lookup xs = all isJust [ T.lookup x tree | x <- xs ]
  where tree = foldl (flip T.insert) T.Nil xs

prop_deletes_seqseq xs = deletes (sort xs) (sort xs)
prop_deletes_seqrnd xs = deletes (sort xs) xs
prop_deletes_rndseq xs = deletes xs (sort xs)
prop_deletes_rndrnd xs = deletes xs xs
deletes :: [Int] -> [Int] -> Bool
deletes xsi xsd = final_check $ foldl delete_and_check (tree, True) xsd
  where tree = foldl (flip T.insert) T.Nil xsi
        delete_and_check (tree, ok) x | ok, tree' <- T.delete x tree, valid tree' = (tree', True)
                                      | otherwise = (tree, False)
        final_check (tree, ok) = ok && size tree == 0

main = do
  let testArgs = stdArgs { maxSuccess = 500 }
  let test name test = putStr (name ++ ": ") >> quickCheckWith testArgs test
  test "inserts seq" prop_inserts_seq
  test "inserts rnd" prop_inserts_rnd
  test "lookups" prop_lookup
  test "deletes seqseq" prop_deletes_seqseq
  test "deletes seqrnd" prop_deletes_seqrnd
  test "deletes rndseq" prop_deletes_rndseq
  test "deletes rndrnd" prop_deletes_rndrnd
