-----------------
-- Index bench --
-----------------

benchIndex len = case ralFromList [1..n] of
  ral -> case rnf $ ralToList ral of
    () -> Criterion.bench (num02 len) $ Criterion.whnf (sumValues (0::Int) (0::Int)) ral
  where sumValues i acc _ | i `seq` acc `seq` False = undefined
        sumValues i acc _ | i >= n = acc
        sumValues i acc ral = sumValues (i+1) (acc + ralLookup i ral) ral

        n = 2^len

benchIndexes lens = Criterion.bgroup "index" [benchIndex len | len <- lens]

------------------
-- Update bench --
------------------

benchUpdate len = case ralFromList [1..n] of
  ral -> case rnf $ ralToList ral of
    () -> Criterion.bench (num02 len) $ Criterion.whnf (updateValues (0::Int)) ral
  where updateValues i ral | i `seq` ral `seq` False = undefined
        updateValues i ral | i >= n = rnf (ralToList ral)
        updateValues i ral = updateValues (i+1) (ralUpdate i (0::Int) ral)

        n = 2^len

benchUpdates lens = Criterion.bgroup "update" [benchUpdate len | len <- lens]

----------------
-- All benchs --
----------------
num02 n | n < 10 = '0' : (show n)
        | otherwise = (show n)

main = Progression.defaultMain $ Criterion.bgroup ""
  [ benchIndexes [8, 12, 16, 18, 20]
  , benchUpdates [8, 10, 12, 14, 16]
  ]
