{-# LANGUAGE BangPatterns, MagicHash, UnboxedTuples, ScopedTypeVariables #-}

module CONSTR()XX ( Array
                 , new
                 , index
                 , update
                 , indexElem
                 , updateElem
                 ) where

import GHC.Exts
import GHC.Prim

DATA_NODES
data Array a = Array {-# UNPACK #-} !Int {-# UNPACK #-} !Int !(Nodes a)

{-# INLINE sizeOfLevel #-}
sizeOfLevel (I# level#) = I# (uncheckedIShiftL# 1# level#)

{-# INLINE getNodeIndex #-}
getNodeIndex (I# i#) (I# l#) = I# (word2Int# (and# (uncheckedShiftRL# (int2Word# i#) l#) (case XX of (I# xx#) -> int2Word# (xx# -# 1#))))

{-# INLINE getElemIndex #-}
getElemIndex (I# i#) = I# (word2Int# (and# (int2Word# i#) (case XX of (I# xx#) -> int2Word# (xx# -# 1#))))


new :: Int -> a -> Array a
new size elem = case getLevel size 0 of
                       level -> Array size level $ create size level elem
  where getLevel !size !level | size <= sizeOfLevel (level + LXX) = level
                              | otherwise = getLevel size (level + LXX)

        create !size !level elem | level == 0 = elemsFromReplicas elem
                                 | otherwise = case size `quot` sizeOfLevel level of
                                                 num -> case size - (num * sizeOfLevel level) of
                                                   rest -> case nodesFromReplicas (create (sizeOfLevel level) (level - LXX) elem) of
                                                     nodes -> if rest > 0 then updateNode (num+1) (create rest (level - LXX) elem) nodes else nodes

index :: Int -> Array a -> a
index i (Array size level arr) | i < 0 || i >= size = error "Out of bounds"
                               | otherwise = index' level arr
  where
        index' !l elems@(Elems {}) = indexElem (getElemIndex i) elems
        index' !l nodes@(Nodes {}) = index' (l - LXX) $! indexNode (getNodeIndex i l) nodes
{-# INLINE index #-}

update :: Int -> a -> Array a -> Array a
update i elem (Array size level arr) | i < 0 || i >= size = error "Out of bounds"
                                     | otherwise = Array size level $ update' level i elem arr
  where
        update' !l !i elem elems@(Elems {}) = updateElem (getElemIndex i) elem elems
        update' !l !i elem nodes@(Nodes {}) = (updateNode (getNodeIndex i l) $! (update' (l - LXX) i elem $! indexNode (getNodeIndex i l) nodes)) nodes
{-# INLINE update #-}




indexElem (I# i) elems@(Elems {}) =
  case unsafeCoerce# elems of
    elems_addr -> case unsafeCoerce# (plusAddr# elems_addr -10#) of
      elems_arr -> case indexArray# elems_arr i of
        (# elem #) -> elem
indexNode (I# i) nodes@(Nodes {}) =
  case unsafeCoerce# nodes of
    nodes_addr -> case unsafeCoerce# (plusAddr# nodes_addr -9#) of
      nodes_arr -> case indexArray# nodes_arr i of
        (# node #) -> node
{-# INLINE indexElem #-}
{-# INLINE indexNode #-}

updateElem (I# 0#) elem elems@(Elems {}) = elems { e00 = elem }
updateElem (I# i) elem elems@(Elems {}) =
  case elems { e00 = elem } of
    elems_copy -> case unsafeCoerce# elems_copy of
      elems_copy_addr -> case plusAddr# elems_copy_addr 2# of
        elems_copy_addr -> case writeAddrOffAddr# elems_copy_addr i (indexAddrOffAddr# elems_copy_addr 0#) realWorld# of
          s -> case writeAddrOffAddr# elems_copy_addr 0# (indexAddrOffAddr# (plusAddr# (unsafeCoerce# elems) 2#) 0#) realWorld# of
            s -> elems_copy
{-# INLINE updateElem #-}

updateNode (I# 0#) node nodes@(Nodes {}) = nodes { n00 = node }
updateNode (I# i) node nodes@(Nodes {}) =
  case nodes { n00 = node } of
    nodes_copy -> case unsafeCoerce# nodes_copy of
      nodes_copy_addr -> case plusAddr# nodes_copy_addr 3# of
        nodes_copy_addr -> case writeAddrOffAddr# nodes_copy_addr i (indexAddrOffAddr# nodes_copy_addr 0#) realWorld# of
          s -> case writeAddrOffAddr# nodes_copy_addr 0# (indexAddrOffAddr# (plusAddr# (unsafeCoerce# nodes) 3#) 0#) realWorld# of
            s -> nodes_copy
{-# INLINE updateNode #-}
