{-# LANGUAGE BangPatterns, MagicHash #-}

module CONSTR()XX ( Array
                 , new
                 , index
                 , update
                 ) where

import GHC.Exts
import GHC.Prim

DATA_NODES
data Array a = Array {-# UNPACK #-} !Int {-# UNPACK #-} !Int !(Nodes a)

{-# INLINE sizeOfLevel #-}
sizeOfLevel (I# level#) = I# (uncheckedIShiftL# 1# level#)

{-# INLINE getNodeIndex #-}
getNodeIndex (I# i#) (I# l#) = I# (word2Int# (and# (uncheckedShiftRL# (int2Word# i#) l#) (case XX of (I# xx#) -> int2Word# (xx# -# 1#))))

{-# INLINE getElemIndex #-}
getElemIndex (I# i#) = I# (word2Int# (and# (int2Word# i#) (case XX of (I# xx#) -> int2Word# (xx# -# 1#))))


new :: Int -> a -> Array a
new size elem = case getLevel size 0 of
                       level -> Array size level $ create size level elem
  where getLevel !size !level | size <= sizeOfLevel (level + LXX) = level
                              | otherwise = getLevel size (level + LXX)

        create !size !level elem | level == 0 = elemsFromReplicas elem
                                 | otherwise = case size `quot` sizeOfLevel level of
                                                 num -> case size - (num * sizeOfLevel level) of
                                                   rest -> case nodesFromReplicas (create (sizeOfLevel level) (level - LXX) elem) of
                                                     nodes -> if rest > 0 then updateNode (num+1) (create rest (level - LXX) elem) nodes else nodes

index :: Int -> Array a -> a
index i (Array size level arr) | i < 0 || i >= size = error "Out of bounds"
                               | otherwise = index' level arr
  where
        index' !l elems@(Elems {}) = indexElem (getElemIndex i) elems
        index' !l nodes@(Nodes {}) = index' (l - LXX) $! indexNode (getNodeIndex i l) nodes
{-# INLINE index #-}

update :: Int -> a -> Array a -> Array a
update i elem (Array size level arr) | i < 0 || i >= size = error "Out of bounds"
                                     | otherwise = Array size level $ update' level i elem arr
  where
        update' !l !i elem elems@(Elems {}) = updateElem (getElemIndex i) elem elems
        update' !l !i elem nodes@(Nodes {}) = (updateNode (getNodeIndex i l) $! (update' (l - LXX) i elem $! indexNode (getNodeIndex i l) nodes)) nodes
{-# INLINE update #-}
